package net.minecraft.client.gui.screens;

import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.client.gui.screens.packs.PackSelectionModel;
import net.minecraft.network.chat.TranslatableComponent;
import java.io.File;
import java.util.function.Consumer;
import net.minecraft.server.packs.repository.Pack;
import net.minecraft.server.packs.repository.PackRepository;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.gui.screens.packs.PackSelectionScreen;

public class DataPackSelectScreen extends PackSelectionScreen {
    private static final ResourceLocation DEFAULT_ICON;
    
    public DataPackSelectScreen(final Screen dqs, final PackRepository<Pack> aar, final Consumer<PackRepository<Pack>> consumer, final File file) {
        super(dqs, new TranslatableComponent("dataPack.title"), runnable -> new PackSelectionModel<>(runnable, (aap, elw) -> elw.bind(DataPackSelectScreen.DEFAULT_ICON), aar, consumer), file);
    }
    
    static {
        DEFAULT_ICON = new ResourceLocation("textures/misc/unknown_pack.png");
    }
}
