package net.minecraft.client.model;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.resources.ResourceLocation;

public class TridentModel extends Model {
    public static final ResourceLocation TEXTURE;
    private final ModelPart pole;
    
    public TridentModel() {
        super(RenderType::entitySolid);
        (this.pole = new ModelPart(32, 32, 0, 6)).addBox(-0.5f, 2.0f, -0.5f, 1.0f, 25.0f, 1.0f, 0.0f);
        final ModelPart dyg2 = new ModelPart(32, 32, 4, 0);
        dyg2.addBox(-1.5f, 0.0f, -0.5f, 3.0f, 2.0f, 1.0f);
        this.pole.addChild(dyg2);
        final ModelPart dyg3 = new ModelPart(32, 32, 4, 3);
        dyg3.addBox(-2.5f, -3.0f, -0.5f, 1.0f, 4.0f, 1.0f);
        this.pole.addChild(dyg3);
        final ModelPart dyg4 = new ModelPart(32, 32, 0, 0);
        dyg4.addBox(-0.5f, -4.0f, -0.5f, 1.0f, 4.0f, 1.0f, 0.0f);
        this.pole.addChild(dyg4);
        final ModelPart dyg5 = new ModelPart(32, 32, 4, 3);
        dyg5.mirror = true;
        dyg5.addBox(1.5f, -3.0f, -0.5f, 1.0f, 4.0f, 1.0f);
        this.pole.addChild(dyg5);
    }
    
    @Override
    public void renderToBuffer(final PoseStack dhl, final VertexConsumer dhp, final int integer3, final int integer4, final float float5, final float float6, final float float7, final float float8) {
        this.pole.render(dhl, dhp, integer3, integer4, float5, float6, float7, float8);
    }
    
    static {
        TEXTURE = new ResourceLocation("textures/entity/trident.png");
    }
}
