package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Mob;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.world.entity.monster.Zombie;
import net.minecraft.resources.ResourceLocation;

public class HuskRenderer extends ZombieRenderer {
    private static final ResourceLocation HUSK_LOCATION;
    
    public HuskRenderer(final EntityRenderDispatcher egm) {
        super(egm);
    }
    
    @Override
    protected void scale(final Zombie bcu, final PoseStack dhl, final float float3) {
        final float float4 = 1.0625f;
        dhl.scale(1.0625f, 1.0625f, 1.0625f);
        super.scale(bcu, dhl, float3);
    }
    
    @Override
    public ResourceLocation getTextureLocation(final Zombie bcu) {
        return HuskRenderer.HUSK_LOCATION;
    }
    
    static {
        HUSK_LOCATION = new ResourceLocation("textures/entity/zombie/husk.png");
    }
}
