package net.minecraft.network.protocol.game;

import org.apache.logging.log4j.LogManager;
import java.util.Iterator;
import net.minecraft.network.protocol.Packet;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.level.block.entity.BeehiveBlockEntity;
import net.minecraft.world.entity.animal.Bee;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.raid.Raid;
import java.util.Collection;
import net.minecraft.world.entity.ai.goal.GoalSelector;
import net.minecraft.world.level.levelgen.structure.StructureStart;
import net.minecraft.world.level.LevelAccessor;
import javax.annotation.Nullable;
import net.minecraft.world.level.pathfinder.Path;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.ChunkPos;
import net.minecraft.network.FriendlyByteBuf;
import io.netty.buffer.Unpooled;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import org.apache.logging.log4j.Logger;

public class DebugPackets {
    private static final Logger LOGGER;
    
    public static void sendGameTestAddMarker(final ServerLevel zd, final BlockPos fu, final String string, final int integer4, final int integer5) {
        final FriendlyByteBuf mg6 = new FriendlyByteBuf(Unpooled.buffer());
        mg6.writeBlockPos(fu);
        mg6.writeInt(integer4);
        mg6.writeUtf(string);
        mg6.writeInt(integer5);
        sendPacketToAllPlayers(zd, mg6, ClientboundCustomPayloadPacket.DEBUG_GAME_TEST_ADD_MARKER);
    }
    
    public static void sendGameTestClearPacket(final ServerLevel zd) {
        final FriendlyByteBuf mg2 = new FriendlyByteBuf(Unpooled.buffer());
        sendPacketToAllPlayers(zd, mg2, ClientboundCustomPayloadPacket.DEBUG_GAME_TEST_CLEAR);
    }
    
    public static void sendPoiPacketsForChunk(final ServerLevel zd, final ChunkPos bph) {
    }
    
    public static void sendPoiAddedPacket(final ServerLevel zd, final BlockPos fu) {
        sendVillageSectionsPacket(zd, fu);
    }
    
    public static void sendPoiRemovedPacket(final ServerLevel zd, final BlockPos fu) {
        sendVillageSectionsPacket(zd, fu);
    }
    
    public static void sendPoiTicketCountPacket(final ServerLevel zd, final BlockPos fu) {
        sendVillageSectionsPacket(zd, fu);
    }
    
    private static void sendVillageSectionsPacket(final ServerLevel zd, final BlockPos fu) {
    }
    
    public static void sendPathFindingPacket(final Level bqb, final Mob aoz, @Nullable final Path czf, final float float4) {
    }
    
    public static void sendNeighborsUpdatePacket(final Level bqb, final BlockPos fu) {
    }
    
    public static void sendStructurePacket(final LevelAccessor bqc, final StructureStart<?> ctz) {
    }
    
    public static void sendGoalSelector(final Level bqb, final Mob aoz, final GoalSelector auh) {
    }
    
    public static void sendRaids(final ServerLevel zd, final Collection<Raid> collection) {
    }
    
    public static void sendEntityBrain(final LivingEntity aoy) {
    }
    
    public static void sendBeeInfo(final Bee ayl) {
    }
    
    public static void sendHiveInfo(final BeehiveBlockEntity cdi) {
    }
    
    private static void sendPacketToAllPlayers(final ServerLevel zd, final FriendlyByteBuf mg, final ResourceLocation uh) {
        final Packet<?> ni4 = new ClientboundCustomPayloadPacket(uh, mg);
        for (final Player bec6 : zd.getLevel().players()) {
            ((ServerPlayer)bec6).connection.send(ni4);
        }
    }
    
    static {
        LOGGER = LogManager.getLogger();
    }
}
