package net.minecraft.server.packs.repository;

import net.minecraft.server.packs.PackResources;
import java.util.function.Consumer;
import net.minecraft.server.packs.VanillaPackResources;

public class ServerPacksSource implements RepositorySource {
    private final VanillaPackResources vanillaPack;
    
    public ServerPacksSource() {
        this.vanillaPack = new VanillaPackResources(new String[] { "minecraft" });
    }
    
    @Override
    public <T extends Pack> void loadPacks(final Consumer<T> consumer, final Pack.PackConstructor<T> a) {
        final T aap4 = Pack.<T>create("vanilla", false, () -> this.vanillaPack, a, Pack.Position.BOTTOM, PackSource.BUILT_IN);
        if (aap4 != null) {
            consumer.accept(aap4);
        }
    }
}
