package net.minecraft.server.packs.resources;

import net.minecraft.util.Unit;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Executor;
import net.minecraft.util.profiling.ProfilerFiller;

public interface ResourceManagerReloadListener extends PreparableReloadListener {
    default CompletableFuture<Void> reload(final PreparationBarrier a, final ResourceManager abc, final ProfilerFiller ami3, final ProfilerFiller ami4, final Executor executor5, final Executor executor6) {
        return a.<Unit>wait(Unit.INSTANCE).thenRunAsync(() -> {
            ami4.startTick();
            ami4.push("listener");
            this.onResourceManagerReload(abc);
            ami4.pop();
            ami4.endTick();
        }, executor6);
    }
    
    void onResourceManagerReload(final ResourceManager abc);
}
