package net.minecraft.tags;

import net.minecraft.resources.ResourceLocation;
import java.util.Set;
import java.util.List;
import net.minecraft.world.level.material.Fluid;

public class FluidTags {
    private static final StaticTagHelper<Fluid> HELPER;
    public static final Tag.Named<Fluid> WATER;
    public static final Tag.Named<Fluid> LAVA;
    
    private static Tag.Named<Fluid> bind(final String string) {
        return FluidTags.HELPER.bind(string);
    }
    
    public static void reset(final TagCollection<Fluid> adg) {
        FluidTags.HELPER.reset(adg);
    }
    
    public static void resetToEmpty() {
        FluidTags.HELPER.resetToEmpty();
    }
    
    public static TagCollection<Fluid> getAllTags() {
        return FluidTags.HELPER.getAllTags();
    }
    
    public static List<StaticTagHelper.Wrapper<Fluid>> getWrappers() {
        return FluidTags.HELPER.getWrappers();
    }
    
    public static Set<ResourceLocation> getMissingTags(final TagCollection<Fluid> adg) {
        return FluidTags.HELPER.getMissingTags(adg);
    }
    
    static {
        HELPER = new StaticTagHelper<Fluid>();
        WATER = bind("water");
        LAVA = bind("lava");
    }
}
