package net.minecraft.world.inventory;

import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.Container;

public class FurnaceFuelSlot extends Slot {
    private final AbstractFurnaceMenu menu;
    
    public FurnaceFuelSlot(final AbstractFurnaceMenu bgj, final Container amz, final int integer3, final int integer4, final int integer5) {
        super(amz, integer3, integer4, integer5);
        this.menu = bgj;
    }
    
    @Override
    public boolean mayPlace(final ItemStack bki) {
        return this.menu.isFuel(bki) || isBucket(bki);
    }
    
    @Override
    public int getMaxStackSize(final ItemStack bki) {
        return isBucket(bki) ? 1 : super.getMaxStackSize(bki);
    }
    
    public static boolean isBucket(final ItemStack bki) {
        return bki.getItem() == Items.BUCKET;
    }
}
