package net.minecraft.world.item;

import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.level.ClipContext;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.level.block.Block;

public class WaterLilyBlockItem extends BlockItem {
    public WaterLilyBlockItem(final Block bvr, final Properties a) {
        super(bvr, a);
    }
    
    @Override
    public InteractionResult useOn(final UseOnContext blv) {
        return InteractionResult.PASS;
    }
    
    @Override
    public InteractionResultHolder<ItemStack> use(final Level bqb, final Player bec, final InteractionHand anf) {
        final BlockHitResult deh5 = Item.getPlayerPOVHitResult(bqb, bec, ClipContext.Fluid.SOURCE_ONLY);
        final BlockHitResult deh6 = deh5.withPosition(deh5.getBlockPos().above());
        final InteractionResult ang7 = super.useOn(new UseOnContext(bec, anf, deh6));
        return new InteractionResultHolder<ItemStack>(ang7, bec.getItemInHand(anf));
    }
}
