package net.minecraft.world.level.block;

import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.phys.shapes.VoxelShape;

public class DeadBushBlock extends BushBlock {
    protected static final VoxelShape SHAPE;
    
    protected DeadBushBlock(final Properties c) {
        super(c);
    }
    
    @Override
    public VoxelShape getShape(final BlockState cfj, final BlockGetter bpg, final BlockPos fu, final CollisionContext der) {
        return DeadBushBlock.SHAPE;
    }
    
    @Override
    protected boolean mayPlaceOn(final BlockState cfj, final BlockGetter bpg, final BlockPos fu) {
        final Block bvr5 = cfj.getBlock();
        return bvr5 == Blocks.SAND || bvr5 == Blocks.RED_SAND || bvr5 == Blocks.TERRACOTTA || bvr5 == Blocks.WHITE_TERRACOTTA || bvr5 == Blocks.ORANGE_TERRACOTTA || bvr5 == Blocks.MAGENTA_TERRACOTTA || bvr5 == Blocks.LIGHT_BLUE_TERRACOTTA || bvr5 == Blocks.YELLOW_TERRACOTTA || bvr5 == Blocks.LIME_TERRACOTTA || bvr5 == Blocks.PINK_TERRACOTTA || bvr5 == Blocks.GRAY_TERRACOTTA || bvr5 == Blocks.LIGHT_GRAY_TERRACOTTA || bvr5 == Blocks.CYAN_TERRACOTTA || bvr5 == Blocks.PURPLE_TERRACOTTA || bvr5 == Blocks.BLUE_TERRACOTTA || bvr5 == Blocks.BROWN_TERRACOTTA || bvr5 == Blocks.GREEN_TERRACOTTA || bvr5 == Blocks.RED_TERRACOTTA || bvr5 == Blocks.BLACK_TERRACOTTA || bvr5 == Blocks.DIRT || bvr5 == Blocks.COARSE_DIRT || bvr5 == Blocks.PODZOL;
    }
    
    static {
        SHAPE = Block.box(2.0, 0.0, 2.0, 14.0, 13.0, 14.0);
    }
}
