package net.minecraft.world.level.block;

import net.minecraft.world.item.ItemStack;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.BlockBehaviour;

public class SpawnerBlock extends BaseEntityBlock {
    protected SpawnerBlock(final Properties c) {
        super(c);
    }
    
    @Override
    public BlockEntity newBlockEntity(final BlockGetter bpg) {
        return new SpawnerBlockEntity();
    }
    
    @Override
    public void spawnAfterBreak(final BlockState cfj, final Level bqb, final BlockPos fu, final ItemStack bki) {
        super.spawnAfterBreak(cfj, bqb, fu, bki);
        final int integer6 = 15 + bqb.random.nextInt(15) + bqb.random.nextInt(15);
        this.popExperience(bqb, fu, integer6);
    }
    
    @Override
    public RenderShape getRenderShape(final BlockState cfj) {
        return RenderShape.MODEL;
    }
    
    @Override
    public ItemStack getCloneItemStack(final BlockGetter bpg, final BlockPos fu, final BlockState cfj) {
        return ItemStack.EMPTY;
    }
}
