package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.world.level.levelgen.structure.ShipwreckPieces;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.block.Rotation;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureManager;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.levelgen.structure.BoundingBox;
import net.minecraft.world.level.levelgen.structure.StructureStart;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.feature.configurations.ShipwreckConfiguration;

public class ShipwreckFeature extends StructureFeature<ShipwreckConfiguration> {
    public ShipwreckFeature(final Codec<ShipwreckConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public StructureStartFactory<ShipwreckConfiguration> getStartFactory() {
        return FeatureStart::new;
    }
    
    public static class FeatureStart extends StructureStart<ShipwreckConfiguration> {
        public FeatureStart(final StructureFeature<ShipwreckConfiguration> cml, final int integer2, final int integer3, final BoundingBox ctd, final int integer5, final long long6) {
            super(cml, integer2, integer3, ctd, integer5, long6);
        }
        
        @Override
        public void generatePieces(final ChunkGenerator cha, final StructureManager cva, final int integer3, final int integer4, final Biome bre, final ShipwreckConfiguration com) {
            final Rotation cap8 = Rotation.getRandom(this.random);
            final BlockPos fu9 = new BlockPos(integer3 * 16, 90, integer4 * 16);
            ShipwreckPieces.addPieces(cva, fu9, cap8, this.pieces, this.random, com);
            this.calculateBoundingBox();
        }
    }
}
