package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureManager;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.levelgen.structure.BoundingBox;
import net.minecraft.world.level.levelgen.structure.BeardedStructureStart;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.feature.configurations.JigsawConfiguration;

public class VillageFeature extends StructureFeature<JigsawConfiguration> {
    public VillageFeature(final Codec<JigsawConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public StructureStartFactory<JigsawConfiguration> getStartFactory() {
        return FeatureStart::new;
    }
    
    public static class FeatureStart extends BeardedStructureStart<JigsawConfiguration> {
        public FeatureStart(final StructureFeature<JigsawConfiguration> cml, final int integer2, final int integer3, final BoundingBox ctd, final int integer5, final long long6) {
            super(cml, integer2, integer3, ctd, integer5, long6);
        }
        
        @Override
        public void generatePieces(final ChunkGenerator cha, final StructureManager cva, final int integer3, final int integer4, final Biome bre, final JigsawConfiguration cnu) {
            final BlockPos fu8 = new BlockPos(integer3 * 16, 0, integer4 * 16);
            VillagePieces.addPieces(cha, cva, fu8, this.pieces, this.random, cnu);
            this.calculateBoundingBox();
        }
    }
}
