package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import net.minecraft.world.level.levelgen.Heightmap;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.serialization.Codec;

public class ChanceHeightmapDoubleDecorator extends FeatureDecorator<ChanceDecoratorConfiguration> {
    public ChanceHeightmapDoubleDecorator(final Codec<ChanceDecoratorConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bqc, final ChunkGenerator cha, final Random random, final ChanceDecoratorConfiguration crf, final BlockPos fu) {
        if (random.nextFloat() >= 1.0f / crf.chance) {
            return Stream.<BlockPos>empty();
        }
        final int integer7 = random.nextInt(16) + fu.getX();
        final int integer8 = random.nextInt(16) + fu.getZ();
        final int integer9 = bqc.getHeight(Heightmap.Types.MOTION_BLOCKING, integer7, integer8) * 2;
        if (integer9 <= 0) {
            return Stream.<BlockPos>empty();
        }
        return Stream.<BlockPos>of(new BlockPos(integer7, random.nextInt(integer9), integer8));
    }
}
