package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.feature.configurations.CountRangeDecoratorConfiguration;

public class CountBiasedRangeDecorator extends SimpleFeatureDecorator<CountRangeDecoratorConfiguration> {
    public CountBiasedRangeDecorator(final Codec<CountRangeDecoratorConfiguration> codec) {
        super(codec);
    }
    
    public Stream<BlockPos> place(final Random random, final CountRangeDecoratorConfiguration cnl, final BlockPos fu) {
        final int integer5;
        final int integer6;
        final int integer7;
        return IntStream.range(0, cnl.count).<BlockPos>mapToObj(integer -> {
            integer5 = random.nextInt(16) + fu.getX();
            integer6 = random.nextInt(16) + fu.getZ();
            integer7 = random.nextInt(random.nextInt(cnl.maximum - cnl.topOffset) + cnl.bottomOffset);
            return new BlockPos(integer5, integer7, integer6);
        });
    }
}
