package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import net.minecraft.world.level.levelgen.Heightmap;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.serialization.Codec;

public class IcebergPlacementDecorator extends FeatureDecorator<ChanceDecoratorConfiguration> {
    public IcebergPlacementDecorator(final Codec<ChanceDecoratorConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bqc, final ChunkGenerator cha, final Random random, final ChanceDecoratorConfiguration crf, final BlockPos fu) {
        if (random.nextFloat() < 1.0f / crf.chance) {
            final int integer7 = random.nextInt(8) + 4 + fu.getX();
            final int integer8 = random.nextInt(8) + 4 + fu.getZ();
            final int integer9 = bqc.getHeight(Heightmap.Types.MOTION_BLOCKING, integer7, integer8);
            return Stream.<BlockPos>of(new BlockPos(integer7, integer9, integer8));
        }
        return Stream.<BlockPos>empty();
    }
}
