package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.serialization.Codec;

public class LakeWaterPlacementDecorator extends FeatureDecorator<ChanceDecoratorConfiguration> {
    public LakeWaterPlacementDecorator(final Codec<ChanceDecoratorConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bqc, final ChunkGenerator cha, final Random random, final ChanceDecoratorConfiguration crf, final BlockPos fu) {
        if (random.nextInt(crf.chance) == 0) {
            final int integer7 = random.nextInt(16) + fu.getX();
            final int integer8 = random.nextInt(16) + fu.getZ();
            final int integer9 = random.nextInt(cha.getGenDepth());
            return Stream.<BlockPos>of(new BlockPos(integer7, integer9, integer8));
        }
        return Stream.<BlockPos>empty();
    }
}
