package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.serialization.Codec;

public class MonsterRoomPlacementDecorator extends FeatureDecorator<ChanceDecoratorConfiguration> {
    public MonsterRoomPlacementDecorator(final Codec<ChanceDecoratorConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bqc, final ChunkGenerator cha, final Random random, final ChanceDecoratorConfiguration crf, final BlockPos fu) {
        final int integer7 = crf.chance;
        final int integer8;
        final int integer9;
        final int integer10;
        return IntStream.range(0, integer7).<BlockPos>mapToObj(integer -> {
            integer8 = random.nextInt(16) + fu.getX();
            integer9 = random.nextInt(16) + fu.getZ();
            integer10 = random.nextInt(cha.getGenDepth());
            return new BlockPos(integer8, integer10, integer9);
        });
    }
}
