package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import net.minecraft.world.level.levelgen.Heightmap;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.feature.configurations.NoneDecoratorConfiguration;

public class TopSolidHeightMapDecorator extends FeatureDecorator<NoneDecoratorConfiguration> {
    public TopSolidHeightMapDecorator(final Codec<NoneDecoratorConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bqc, final ChunkGenerator cha, final Random random, final NoneDecoratorConfiguration cnz, final BlockPos fu) {
        final int integer7 = random.nextInt(16) + fu.getX();
        final int integer8 = random.nextInt(16) + fu.getZ();
        final int integer9 = bqc.getHeight(Heightmap.Types.OCEAN_FLOOR_WG, integer7, integer8);
        return Stream.<BlockPos>of(new BlockPos(integer7, integer9, integer8));
    }
}
